DCMTK Version 3.7.0 OFFIS DICOM Toolkit

Static Public Member Functions | Static Private Member Functions | List of all members
DiCurveFitting< T1, T2, T3 > Class Template Reference

Template class for polynomial curve fitting algorithm. More...

## Static Public Member Functions
static int | calculateCoefficients (const T1 *x, const T2 *y, const unsigned int n, const unsigned int o, T3 *c)
| calculate coefficients for resulting polynomial function. More...
static int | calculateValues (const T1 xs, const T1 xe, T2 *y, const unsigned int n, const unsigned int o, const T3 *c)
| calculate y coordinates for the given range of x coordinates. More...

## Static Private Member Functions
static void | convertValue (const T3 input, Uint8 &output)
| helper routine: convert to unsigned 8 bit value More...
static void | convertValue (const T3 input, Sint8 &output)
| helper routine: convert to signed 8 bit value More...
static void | convertValue (const T3 input, Uint16 &output)
| helper routine: convert to unsigned 16 bit value More...
static void | convertValue (const T3 input, Sint16 &output)
| helper routine: convert to signed 16 bit value More...
static void | convertValue (const T3 input, double &output)
| helper routine: convert to floating point value (double precision) More...
static int | solve (T3 *a, T3 *b, const unsigned int n)
| solve the equation given by the two matrixes. More...

## Detailed Description

### template<class T1, class T2, class T3 = double>
class DiCurveFitting< T1, T2, T3 >

Template class for polynomial curve fitting algorithm.

## Member Function Documentation

## ◆ calculateCoefficients()

template<class T1 , class T2 , class T3 = double>

static int DiCurveFitting< T1, T2, T3 >::calculateCoefficients | ( | const T1 * | x,
|  | const T2 * | y,
|  | const unsigned int | n,
|  | const unsigned int | o,
|  | T3 * | c
| ) |  |
| inline static

calculate coefficients for resulting polynomial function.

T1 = type of x coordinates T2 = type of y coordinates T3 = type of coefficients (and for internal calculations)

Parameters

  x | array with x coordinates of given points
  y | array with y coordinates of given points
  n | number of entries in array (= points)
  o | order of polynomial function
  c | array to store the resulting coefficients (o+1 entries !)

Returns
  true if successful, false otherwise

## ◆ calculateValues()

template<class T1 , class T2 , class T3 = double>

static int DiCurveFitting< T1, T2, T3 >::calculateValues | ( | const T1 | xs,
|  | const T1 | xe,
|  | T2 * | y,
|  | const unsigned int | n,
|  | const unsigned int | o,
|  | const T3 * | c
| ) |  |
| inline static

calculate y coordinates for the given range of x coordinates.

The polynomial function is defined by the specified coefficients. T1 = type of x coordinates T2 = type of y coordinates T3 = type of coefficients (and for internal calculations)

Parameters

  xs | first x coordinate for computation
  xe | last x coordinate for computation
  y | array to store the resulting y coordinates (n entries !)
  n | number of entries in array (= points)
  o | order of polynomial function
  c | array of coefficients computed by the above method (o+1 entries !)

Returns
  true if successful, false otherwise

## ◆ convertValue() [1/5]

template<class T1 , class T2 , class T3 = double>

static void DiCurveFitting< T1, T2, T3 >::convertValue | ( | const T3 | input,
|  | double & | output
| ) |  |
| inline static private

helper routine: convert to floating point value (double precision)

Parameters

  input | input value to be converted
  output | output value (double)

Returns
  output value

## ◆ convertValue() [2/5]

template<class T1 , class T2 , class T3 = double>

static void DiCurveFitting< T1, T2, T3 >::convertValue | ( | const T3 | input,
|  | Sint16 & | output
| ) |  |
| inline static private

helper routine: convert to signed 16 bit value

Parameters

  input | input value to be converted
  output | output value (range: -32768..32767)

Returns
  output value

## ◆ convertValue() [3/5]

template<class T1 , class T2 , class T3 = double>

static void DiCurveFitting< T1, T2, T3 >::convertValue | ( | const T3 | input,
|  | Sint8 & | output
| ) |  |
| inline static private

helper routine: convert to signed 8 bit value

Parameters

  input | input value to be converted
  output | output value (range: -128..127)

Returns
  output value

## ◆ convertValue() [4/5]

template<class T1 , class T2 , class T3 = double>

static void DiCurveFitting< T1, T2, T3 >::convertValue | ( | const T3 | input,
|  | Uint16 & | output
| ) |  |
| inline static private

helper routine: convert to unsigned 16 bit value

Parameters

  input | input value to be converted
  output | output value (range: 0..65535)

Returns
  output value

## ◆ convertValue() [5/5]

template<class T1 , class T2 , class T3 = double>

static void DiCurveFitting< T1, T2, T3 >::convertValue | ( | const T3 | input,
|  | Uint8 & | output
| ) |  |
| inline static private

helper routine: convert to unsigned 8 bit value

Parameters

  input | input value to be converted
  output | output value (range: 0..255)

Returns
  output value

## ◆ solve()

template<class T1 , class T2 , class T3 = double>

static int DiCurveFitting< T1, T2, T3 >::solve | ( | T3 * | a,
|  | T3 * | b,
|  | const unsigned int | n
| ) |  |
| inline static private

solve the equation given by the two matrixes.

T3 = type of coefficients (and for internal calculations)

Parameters

  a | first matrix (array of values)
  b | second matrix (array of values)
  n | number of entries in array

Returns
  true if successful, false otherwise

The documentation for this class was generated from the following file:

- dcmimgle/include/dcmtk/dcmimgle/dicrvfit.h

Generated on Mon Dec 15 2025 for DCMTK Version 3.7.0 by Doxygen 1.9.1